package polyglot.ext.ibex.ast;

import polyglot.ast.*;
import polyglot.ext.jl.ast.*;
import polyglot.types.*;
import polyglot.ext.ibex.types.*;
import polyglot.util.*;
import java.util.*;

/**
 * NodeFactory for ibex extension.
 */
public class IbexNodeFactory_c extends NodeFactory_c implements IbexNodeFactory {
    public IbexNodeFactory_c() {
        super(new IbexExtFactory_c(), new IbexDelFactory_c());
    }
    
    protected IbexNodeFactory_c(ExtFactory extFact) {
        super(extFact);
    }

    public TerminalDecl TerminalDecl(Position pos, Flags flags, TypeNode type, String name) {
        TerminalDecl n = new TerminalDecl_c (pos, flags, type, name);
        return n;
    }

    public RuleDecl RuleDecl(Position pos, Flags flags, TypeNode type, String lhs, List choices, boolean isStart) {
        RuleDecl n = new RuleDecl_c(pos, flags, type, lhs, choices, isStart);
        return n;
    }

    public RhsCaseNode RhsCaseNode(Position pos, List elements, Block action) {
        return new RhsCaseNode_c(pos, elements, action);
    }

    public RhsMergeNode RhsMergeNode(Position pos, List elements1, List elements2, Block action) {
        return new RhsMergeNode_c(pos, elements1, elements2, action);
    }

    public Tagged Tagged(Position pos, String tag, SymbolNode sym) {
        return new Tagged_c(pos, tag, sym);
    }

    public SymbolNode SymbolNode(Position pos, String name) {
        return new SymbolNode_c(pos, name);
    }

    public SuperSymbolNode SuperSymbolNode(Position pos, String name) {
        return new SuperSymbolNode_c(pos, name);
    }
}
