package polyglot.ext.ibex.ast;

import polyglot.ast.*;
import polyglot.ext.jl.ast.*;
import polyglot.types.*;
import polyglot.ext.ibex.types.*;
import polyglot.ext.ibex.visit.*;
import polyglot.visit.*;
import polyglot.util.*;
import java.util.*;

/**
 * Node representing a semantic action.
 */
public class SuperSymbolNode_c extends SymbolNode_c implements SuperSymbolNode {
    public SuperSymbolNode_c(Position pos, String name) {
        super(pos, name);
    }

    public Node disambiguate(AmbiguityRemover ar) throws SemanticException {
        IbexTypeSystem ts = (IbexTypeSystem) ar.typeSystem();
        IbexNodeFactory nf = (IbexNodeFactory) ar.nodeFactory();
        Context c = (Context) ar.context();

        if (ar.kind() != AmbiguityRemover.ALL) {
            return this;
        }

        ParserType pt = (ParserType) c.currentClass();

        if (pt.superType() instanceof ParserType) {
            pt = (ParserType) pt.superType();
            Symbol sym = ts.findSymbol(pt, name);
            return symbolInstance(sym);
        }
        else {
            throw new SemanticException("Superclass \"" + pt.superType() +
                                        "\" of \"" + pt +
                                        "\" is not a parser.", position());
        }
    }

    public Node rewrite(Rewriter rw) {
        return this;
    }
}
