package polyglot.ext.op;

import polyglot.ast.*;
import polyglot.ext.jl.ast.*;
import polyglot.types.*;
import polyglot.frontend.*;
import polyglot.visit.*;
import polyglot.util.*;

public class OPInstanceOf extends Instanceof_c { 
  public OPInstanceOf(Position pos, Expr expr, TypeNode tn) {
    super(pos, expr, tn);
  }

  public Node typeCheck(TypeChecker tc) throws SemanticException {
    Type rtype = compareType.type();
    Type ltype = expr.type();

    if (! tc.typeSystem().isCastValid(ltype, rtype)) {
      throw new SemanticException(
                 "Left operand of \"instanceof\" must be castable to "
                 + "the right operand.");
    }

    return type(tc.typeSystem().Boolean());
  }
}
