package polyglot.ext.op;

import polyglot.ast.*;
import polyglot.parse.*;
import polyglot.types.*;
import polyglot.util.*;

/**
 * Wrapper for a OP parser.
 */
public class OPParserWrapper implements ParserWrapper {
	protected Grm parser;
	
	public OPParserWrapper(Grm parser) {
		this.parser = parser;
	}
	
	public NodeFactory nodeFactory() {
		return parser.nf;
	}
	
	public TypeSystem typeSystem() {
		return parser.ts;
	}
	
	public void die(String message, Position pos) throws Exception {
		parser.die(message, pos);
	}
	
	public void die(Position pos) throws Exception {
		parser.die(pos);
	}
}

