package polyglot.ext.polyj.ast;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.visit.*;

import java.util.*;

/**
 * An <code>AmbNameParam</code> is a name used as a parameter in an instantiation.
 * It is ambiguous whether this is a local, field, or type.  It must
 * resolve to either a <code>TypeParam</code> or <code>ExprParam</code>.
 */
public interface AmbNameParam extends ParamNode {
    /**
     * The name used as a parameter.  We represent
     * it as an <code>AmbReceiver</code> since an
     * <code>AmbReceiver</code> is also a name, and since
     * parameters are receivers (types or expressions).
     */
    AmbReceiver name();
    AmbNameParam name(AmbReceiver name);
}
