package polyglot.ext.polyj.types;

import polyglot.types.*;
import polyglot.util.*;

import polyglot.ext.jl.types.*;

import polyglot.ext.polyj.ast.*;
import polyglot.ext.polyj.visit.*;

import java.util.*;

/**
 * A WrappedClassType is a PolyJClassType that has been wrapped by
 * a TypeWrapper in order to implement lazy parameter substition.
 */
public interface WrappedClassType extends PolyJClassType, SubstType {

    // Different implementations
    ClassType.Kind kind();
    List methods();
    List constructors();
    MethodInstance originalMethod(MethodInstance mi);
    ConstructorInstance originalConstructor(ConstructorInstance ci);
    List fields();
    Type superType();
    List interfaces();
    String fullName();
    String name();
    polyglot.types.Package package_();
    Flags flags();
    boolean isNested();
    boolean isLocal();
    boolean isAnonymous();
    ClassType outer();
    List memberClasses();
    ClassType memberClassNamed(String name);
    String translate(Resolver c);

    // Operations on WrappedTypes
    ClassType wrappedClass();
    List args();
    PolyJTypeWrapper substitutor();
}

