package polyglot.ext.polyj.util;

import polyglot.types.*;
import polyglot.ext.polyj.types.*;
import polyglot.ext.polyj.visit.*;

public class AdapterBinding_c implements AdapterBinding {
    int bindingNum;
    PolyJClassType assistant;
    ClassType instantiation;
    PolyJTypeSystem ts;

    public AdapterBinding_c(PolyJClassType assistant, ClassType instantiation)
    {
        this.instantiation = instantiation;
        this.assistant = assistant;
        this.ts = (PolyJTypeSystem) assistant.typeSystem();
    }

    public String name() {
        return "$GetWhere$" + PolyJTranslator.mangle(
            instantiation.toString());
    }

    public ClassType instantiatedType() {
        return instantiation;
    }

    public PolyJClassType assistingType() {
        return assistant;
    }

    public String toString() {
        return "(inst: " + instantiation + ", asst: " + assistant + ")";
    }
}

