package polyglot.ext.polyj.util;

import polyglot.types.*;
import polyglot.util.*;
import polyglot.ext.polyj.types.*;
import polyglot.ext.polyj.visit.*;

public class NewArrayBinding_c implements NewArrayBinding {
    protected ParamType param;
    protected int dims;
    protected String name;
    protected String type;


    public NewArrayBinding_c(ParamType param, int dims, ClassType enclosing,
        PolyJTypeSystem ts) 
    {
        this.param = param;
        this.dims = dims;

        name = PolyJTranslator.adapterMethodName("a_new", param, enclosing, ts);

        // The type of an array of parameters is
        // Object[]...[]  where there are dims-1 []'s.
        // The innermost array is represented as an Object.
        StringBuffer sb = new StringBuffer();
        sb.append("Object");
        for(int i = 1; i <= dims-1; i++){
            sb.append("[]");
        }
        type = sb.toString();
    }

    public ParamType param() {
        return param;
    }

    public int dims() {
        return dims();
    }

    public String name() {
        return name;
    }

    public String type() {
        return type;
    }
}
