package polyglot.ext.pure.types;

import polyglot.types.*;
import polyglot.ext.jl.types.TypeSystem_c;

public class PureTypeSystem_c extends TypeSystem_c implements PureTypeSystem {
    // TODO: implement new methods in PureTypeSystem.
    // TODO: override methods as needed from TypeSystem_c.

    Flags PURE;

    protected void initTypes() {
        // Do not initialize types.  This allows us to compile
        // java.lang.Object.
    }

    protected void initFlags() {
        super.initFlags();
        PURE = createNewFlag("pure",
                             Public().Private().Protected().Static().Final());
    }

    public Flags Pure() {
        return PURE;
    }

    public void checkMethodFlags(Flags flags) throws SemanticException {
        super.checkMethodFlags(flags.clear(PURE));
    }

    public void checkConstructorFlags(Flags flags) throws SemanticException {
        super.checkConstructorFlags(flags.clear(PURE));
    }

    public boolean canOverride(MethodInstance mi, MethodInstance mj) {
        // Cannot override pure method with a non-pure method.
        if (! mi.flags().contains(PURE) && mj.flags().contains(PURE)) {
            return false;
        }

        return super.canOverride(mi, mj);
    }
}
